/*
 Rocrail - Model Railroad Software

 Copyright (C) Rob Versluis <r.j.versluis@rocrail.net>

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 3
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#ifndef __mgv141dlg__
#define __mgv141dlg__

/**
@file
Subclass of mgv141gen, which is generated by wxFormBuilder.
*/

#include "mgv141dlggen.h"
#include "wx/timer.h"

#include "rocs/public/node.h"
#include "rocs/public/queue.h"

/** Implementing mgv141gen */
class MGV141Dlg : public mgv141gen
{
  void sendPacket();
  void makePacket( int offset, int port, int val1, bool sv_set, bool sendnow );
  void OnTimer(wxTimerEvent& event);
  void queryAddresses();
  void evaluateEvent( int type, int low, int sub, int sv, int val, int ver );

  int m_iLowAddress;
  int m_iSubAddress;
  iOQueue m_Queue;
  iONode m_SendedCmd;
  wxTimer* m_Timer;
  int m_TabAlign;
  int m_SV[256];


protected:
	// Handlers for mgv141gen events.
  void onUnitSelected( wxCommandEvent& event );
  void onQuery( wxCommandEvent& event );
	void onUnitSet( wxCommandEvent& event );
	void onWriteAll( wxCommandEvent& event );
	void onReadAll( wxCommandEvent& event );
	void onOK( wxCommandEvent& event );
  void initLabels();

public:
	/** Constructor */
	MGV141Dlg( wxWindow* parent );
	void event( iONode event );
};

#endif // __mgv141dlg__
